/*
(C) ALVIDI 22.7.2012
 
Disclaimer
----------
Wir haften nicht fr die Eignung der Software fr einen bestimmten, vom Kunden beabsichtigten Verwendungszweck.
We are not liable for the problems, which occur during incorrect usage of our products.

Wir bernehmen keine Haftung fr die Fehler, die im Laufe der Nutzung auftreten knnen.
We don't take liability for mistakes, which may occur while using our products.

Wir bernehmen keine Verantwortung fr mgliche Schden, die bei der Nutzung des Programms entstehen knnen.
We don't take responsibility for possible damages, which may happen while using our products.

Dieses Programm ist freie Software. Sie knnen es verffentlichen, weitergeben und/oder modifizieren. 
This program is freeware. You may publish it, refer and/or modify.

Diese Software ist kompatibel mit dem AVR32 Modul http://alvidi.de/avr32_modul.html
This software is compatible with the AVR32 Module http://alvidi.de/avr32_module.html
*/

#ifndef _UC3AEB_H_
#define _UC3AEB_H_

#include "compiler.h"

/* Osc32 frequency: Hz.*/
#define FOSC32          32768      
       
/* Osc32 startup time: RCOsc periods. */                    
#define OSC32_STARTUP   AVR32_PM_OSCCTRL32_STARTUP_8192_RCOSC

/* Osc0 frequency: Hz. */
#define FOSC0           12000000                         
/* Osc0 startup time: RCOsc periods.*/     
#define OSC0_STARTUP    AVR32_PM_OSCCTRL0_STARTUP_2048_RCOSC  

/* These are documented in services/basic/clock/uc3a0_a1/osc.h */
#define BOARD_OSC0_HZ           12000000
#define BOARD_OSC0_STARTUP_US   17000
#define BOARD_OSC0_IS_XTAL      true
#define BOARD_OSC32_HZ          32768
#define BOARD_OSC32_STARTUP_US  71000
#define BOARD_OSC32_IS_XTAL     true

/* Push Button with depended GPIO Connection */
#define GPIO_PUSH_BUTTON              AVR32_PIN_PA20
#define GPIO_PUSH_BUTTON_PRESSED      0

/* RS232 USART 0 Definitions */

#define RS232_USART_0                 (&AVR32_USART0)
#define RS232_USART_0_RX_PIN          AVR32_USART0_RXD_0_0_PIN
#define RS232_USART_0_RX_FUNCTION     AVR32_USART0_RXD_0_0_FUNCTION
#define RS232_USART_0_TX_PIN          AVR32_USART0_TXD_0_0_PIN
#define RS232_USART_0_TX_FUNCTION     AVR32_USART0_TXD_0_0_FUNCTION
#define RS232_USART_0_CLOCK_MASK      AVR32_USART0_CLK_PBA

/* RS232 USART 1 Definitions */

#define RS232_USART_1                 (&AVR32_USART1)
#define RS232_USART_1_RX_PIN          AVR32_USART1_RXD_0_0_PIN
#define RS232_USART_1_RX_FUNCTION     AVR32_USART1_RXD_0_0_FUNCTION
#define RS232_USART_1_TX_PIN          AVR32_USART1_TXD_0_0_PIN
#define RS232_USART_1_TX_FUNCTION     AVR32_USART1_TXD_0_0_FUNCTION
#define RS232_USART_1_CLOCK_MASK      AVR32_USART1_CLK_PBA

#endif  // _UC3AEB_H_
