/*
(C) ALVIDI 14.4.2011
 
Disclaimer
----------
Wir haften nicht fr die Eignung der Software fr einen bestimmten, vom Kunden beabsichtigten Verwendungszweck.
We are not liable for the problems, which occur during incorrect usage of our products.

Wir bernehmen keine Haftung fr die Fehler, die im Laufe der Nutzung auftreten knnen.
We don't take liability for mistakes, which may occur while using our products.

Wir bernehmen keine Verantwortung fr mgliche Schden, die bei der Nutzung des Programms entstehen knnen.
We don't take responsibility for possible damages, which may happen while using our products.

Dieses Programm ist freie Software. Sie knnen es verffentlichen, weitergeben und/oder modifizieren. 
This program is freeware. You may publish it, refer and/or modify.

Diese Software ist kompatibel mit dem AVR32 Board http://alvidi.de/avr32_board.html
This software is compatible with the AVR32 Board http://alvidi.de/avr32_board_en.html
*/

#ifndef _UC3AVRBIT_H_
#define _UC3AVRBIT_H_

#include "led_func.h"
#include "compiler.h"

/* Osc32 frequency: Hz.*/
#define FOSC32          32768      
       
/* Osc32 startup time: RCOsc periods. */                    
#define OSC32_STARTUP   AVR32_PM_OSCCTRL32_STARTUP_8192_RCOSC

/* Osc0 frequency: Hz. */
#define FOSC0           12000000                         
/* Osc0 startup time: RCOsc periods.*/     
#define OSC0_STARTUP    AVR32_PM_OSCCTRL0_STARTUP_2048_RCOSC  

/* These are documented in services/basic/clock/uc3a0_a1/osc.h */
#define BOARD_OSC0_HZ           12000000
#define BOARD_OSC0_STARTUP_US   17000
#define BOARD_OSC0_IS_XTAL      true
#define BOARD_OSC32_HZ          32768
#define BOARD_OSC32_STARTUP_US  71000
#define BOARD_OSC32_IS_XTAL     true

/* Part header file of used SDRAM(s). */
#define SDRAM_PART_HDR  "mt48lc16m16a2tg7e.h"

/* Data bus width to use the SDRAM */
#define SDRAM_DBW       16


/* LEDs with depended GPIO Connections */
#define LED0_GPIO   AVR32_PIN_PX12
#define LED1_GPIO   AVR32_PIN_PX13
#define LED2_GPIO   AVR32_PIN_PX15
#define LED3_GPIO   AVR32_PIN_PX16

/* Push Button with depended GPIO Connection */
#define GPIO_PUSH_BUTTON              AVR32_PIN_PA20
#define GPIO_PUSH_BUTTON_PRESSED      0

/* RS232 USART 0 Definitions */

#define RS232_USART_0                 (&AVR32_USART0)
#define RS232_USART_0_RX_PIN          AVR32_USART0_RXD_0_0_PIN
#define RS232_USART_0_RX_FUNCTION     AVR32_USART0_RXD_0_0_FUNCTION
#define RS232_USART_0_TX_PIN          AVR32_USART0_TXD_0_0_PIN
#define RS232_USART_0_TX_FUNCTION     AVR32_USART0_TXD_0_0_FUNCTION
#define RS232_USART_0_CLOCK_MASK      AVR32_USART0_CLK_PBA

/* RS232 USART 1 Definitions */

#define RS232_USART_1                 (&AVR32_USART1)
#define RS232_USART_1_RX_PIN          AVR32_USART1_RXD_0_0_PIN
#define RS232_USART_1_RX_FUNCTION     AVR32_USART1_RXD_0_0_FUNCTION
#define RS232_USART_1_TX_PIN          AVR32_USART1_TXD_0_0_PIN
#define RS232_USART_1_TX_FUNCTION     AVR32_USART1_TXD_0_0_FUNCTION
#define RS232_USART_1_CLOCK_MASK      AVR32_USART1_CLK_PBA

/* EEPROM TWI Definitions */

#define EEPROM_TWI_SDA_PIN			  AVR32_TWI_SDA_0_0_PIN
#define EEPROM_TWI_SDA_FUNCTION		  AVR32_TWI_SDA_0_0_FUNCTION
#define EEPROM_TWI_SCL_PIN			  AVR32_TWI_SCL_0_0_PIN
#define EEPROM_TWI_SCL_FUNCTION		  AVR32_TWI_SCL_0_0_FUNCTION

/* AT45DBX Data Flash Memory with depended GPIO and SPI Connections */
#define AT45DBX_SPI                 (&AVR32_SPI0)
#define AT45DBX_SPI_NPCS            1
#define AT45DBX_SPI_SCK_PIN         AVR32_SPI0_SCK_0_0_PIN
#define AT45DBX_SPI_SCK_FUNCTION    AVR32_SPI0_SCK_0_0_FUNCTION
#define AT45DBX_SPI_MISO_PIN        AVR32_SPI0_MISO_0_0_PIN
#define AT45DBX_SPI_MISO_FUNCTION   AVR32_SPI0_MISO_0_0_FUNCTION
#define AT45DBX_SPI_MOSI_PIN        AVR32_SPI0_MOSI_0_0_PIN
#define AT45DBX_SPI_MOSI_FUNCTION   AVR32_SPI0_MOSI_0_0_FUNCTION
#define AT45DBX_SPI_NPCS0_PIN       AVR32_SPI0_NPCS_1_0_PIN
#define AT45DBX_SPI_NPCS0_FUNCTION  AVR32_SPI0_NPCS_1_0_FUNCTION

/* microSD Connector with depended GPIO and SPI Connections */
#define SD_MMC_CARD_DETECT_PIN      AVR32_PIN_PA14
#define SD_MMC_SPI                  (&AVR32_SPI0)
#define SD_MMC_SPI_NPCS             0
#define SD_MMC_SPI_SCK_PIN          AVR32_SPI0_SCK_0_0_PIN
#define SD_MMC_SPI_SCK_FUNCTION     AVR32_SPI0_SCK_0_0_FUNCTION
#define SD_MMC_SPI_MISO_PIN         AVR32_SPI0_MISO_0_0_PIN
#define SD_MMC_SPI_MISO_FUNCTION    AVR32_SPI0_MISO_0_0_FUNCTION
#define SD_MMC_SPI_MOSI_PIN         AVR32_SPI0_MOSI_0_0_PIN
#define SD_MMC_SPI_MOSI_FUNCTION    AVR32_SPI0_MOSI_0_0_FUNCTION
#define SD_MMC_SPI_NPCS_PIN         AVR32_SPI0_NPCS_0_0_PIN
#define SD_MMC_SPI_NPCS_FUNCTION    AVR32_SPI0_NPCS_0_0_FUNCTION

/* MACB connections to the PHY_KSZ8041TL external phy controller */
#define MACB_INTERRUPT_PIN          AVR32_PIN_PA24
#define EXTPHY_MACB_INTERRUPT_PIN   MACB_INTERRUPT_PIN 

#define EXTPHY_MACB                 (&AVR32_MACB)
#define EXTPHY_MACB_MDC_PIN         AVR32_MACB_MDC_0_PIN
#define EXTPHY_MACB_MDC_FUNCTION    AVR32_MACB_MDC_0_FUNCTION
#define EXTPHY_MACB_MDIO_PIN        AVR32_MACB_MDIO_0_PIN
#define EXTPHY_MACB_MDIO_FUNCTION   AVR32_MACB_MDIO_0_FUNCTION
#define EXTPHY_MACB_RXD_0_PIN       AVR32_MACB_RXD_0_PIN
#define EXTPHY_MACB_RXD_0_FUNCTION  AVR32_MACB_RXD_0_FUNCTION
#define EXTPHY_MACB_RXD_1_PIN       AVR32_MACB_RXD_1_PIN
#define EXTPHY_MACB_RXD_1_FUNCTION  AVR32_MACB_RXD_1_FUNCTION
#define EXTPHY_MACB_TXD_0_PIN       AVR32_MACB_TXD_0_PIN
#define EXTPHY_MACB_TXD_0_FUNCTION  AVR32_MACB_TXD_0_FUNCTION
#define EXTPHY_MACB_TXD_1_PIN       AVR32_MACB_TXD_1_PIN
#define EXTPHY_MACB_TXD_1_FUNCTION  AVR32_MACB_TXD_1_FUNCTION
#define EXTPHY_MACB_TX_EN_PIN       AVR32_MACB_TX_EN_0_PIN
#define EXTPHY_MACB_TX_EN_FUNCTION  AVR32_MACB_TX_EN_0_FUNCTION
#define EXTPHY_MACB_RX_ER_PIN       AVR32_MACB_RX_ER_0_PIN
#define EXTPHY_MACB_RX_ER_FUNCTION  AVR32_MACB_RX_ER_0_FUNCTION
#define EXTPHY_MACB_RX_DV_PIN       AVR32_MACB_RX_DV_0_PIN
#define EXTPHY_MACB_RX_DV_FUNCTION  AVR32_MACB_RX_DV_0_FUNCTION
#define EXTPHY_MACB_TX_CLK_PIN      AVR32_MACB_TX_CLK_0_PIN
#define EXTPHY_MACB_TX_CLK_FUNCTION AVR32_MACB_TX_CLK_0_FUNCTION

/* Phy Address (set through strap options) */
#define EXTPHY_PHY_ADDR             0x01

/* Configure the ethernet phy component to use the KSZ8041TL phy */
#define PHY_KSZ8041TL

#endif  // _UC3AVRBIT_H_
