/*
(C) ALVIDI 22.7.2012
 
Disclaimer
----------
Wir haften nicht fr die Eignung der Software fr einen bestimmten, vom Kunden beabsichtigten Verwendungszweck.
We are not liable for the problems, which occur during incorrect usage of our products.

Wir bernehmen keine Haftung fr die Fehler, die im Laufe der Nutzung auftreten knnen.
We don't take liability for mistakes, which may occur while using our products.

Wir bernehmen keine Verantwortung fr mgliche Schden, die bei der Nutzung des Programms entstehen knnen.
We don't take responsibility for possible damages, which may happen while using our products.

Dieses Programm ist freie Software. Sie knnen es verffentlichen, weitergeben und/oder modifizieren. 
This program is freeware. You may publish it, refer and/or modify.

Diese Software ist kompatibel mit dem AVR32 Modul mit EEPROM http://alvidi.de/avr32_modul_bmb.html
This software is compatible with the AVR32 Module with EEPROM http://alvidi.de/avr32_module_bmb.html
*/

#ifndef EEPROM_H_
#define EEPROM_H_
//#################################################################################################################
//	HERE: YOU CAN SET EEPROM PARAMETER

#define EEPROM_ADDRESS		0						//Address of EEPROM
#define EEPROM_TYPE			64						//Microchip 24LC64 8K x 8 (64Kbit)
#define ADDRESS_LENGTH		2						//0 < [1] <= 256 bytes < [2] <= 64K Bytes < [3] < 16.384M Bytes
#define EEPROM_PAGE_SIZE	32						//EEPROM page size in bytes
#define EEPROM_SPEED		100000					//EEPROM speed
//#################################################################################################################
#define CHIP_ADDRESS		(EEPROM_ADDRESS + 0x50)
#define EEPROM_SIZE			((EEPROM_TYPE/8)*1024)

#define EEPROM_SUCCESS		0
#define EEPROM_ERROR		1
/****************************************************************************************************************/
extern void eeprom_init(unsigned int f_cpu);										//EEPROM initializaton

extern int  eeprom_write_byte(unsigned int addr, unsigned char data);				//write one byte to EEPROM

extern int  eeprom_write_block(unsigned int addr, char *data, unsigned int length);	//write string to EEPROM (max. EEPROM_PAGE_SIZE)

extern int 	eeprom_read_byte(unsigned int addr);									//read one byte of EEPROM

extern void eeprom_read_block(unsigned int addr, char *data, unsigned int length);	//read string of EEPROM (max. EEPROM_PAGE_SIZE)
/****************************************************************************************************************/
#endif /*EEPROM_H_*/
