/*
(C) ALVIDI 22.7.2012
 
Disclaimer
----------
Wir haften nicht fr die Eignung der Software fr einen bestimmten, vom Kunden beabsichtigten Verwendungszweck.
We are not liable for the problems, which occur during incorrect usage of our products.

Wir bernehmen keine Haftung fr die Fehler, die im Laufe der Nutzung auftreten knnen.
We don't take liability for mistakes, which may occur while using our products.

Wir bernehmen keine Verantwortung fr mgliche Schden, die bei der Nutzung des Programms entstehen knnen.
We don't take responsibility for possible damages, which may happen while using our products.

Dieses Programm ist freie Software. Sie knnen es verffentlichen, weitergeben und/oder modifizieren. 
This program is freeware. You may publish it, refer and/or modify.

Diese Software ist kompatibel mit dem AVR32 Modul mit EEPROM http://alvidi.de/avr32_modul_bmb.html
This software is compatible with the AVR32 Module with EEPROM http://alvidi.de/avr32_module_bmb.html
*/


#include <avr32/io.h>
#include "board.h"
#include "print_funcs.h"
#include "gpio.h"
#include "pm.h"
#include "intc.h"
#include "eeprom.h"
#include "power_clocks_lib.h"

int main(void)
{
	char buffer[20];
	pcl_switch_to_osc(PCL_OSC0, FOSC0, OSC0_STARTUP);

	Disable_global_interrupt();	//	cli();
	INTC_init_interrupts();		//initialization of interrupt controller


	//Baudrate settings is in "print_funcs.h"
	init_dbg_rs232(FOSC0);
	
	/*clear screen*/
	print_dbg("\x1B[2J\x1B[H");
	print_dbg("USART initialization..........OK!\n\r");

	Enable_global_interrupt(); 	//	sei();

	print_dbg("EEPROM initialization.........");
	
	/*EEPROM initialization*/
	eeprom_init(FOSC0);
	
	/*write first byte to EEPROM address 0*/
	eeprom_write_byte(0,0x41);
	
	/*write second byte to EEPROM address 1*/
	eeprom_write_byte(1,0x42);
	
	/*read first byte from EEPROM address 0*/
	U8 prom1=eeprom_read_byte(0);
	
	/*read second byte from EEPROM address 1*/
	U8 prom2=eeprom_read_byte(1);
	
	/*compare written bytes with read ones*/
	if(prom1==0x41 && prom2==0x42)
	  print_dbg("OK!\n\r");
	else
	  print_dbg("ERROR!\n\r");
	
	/*write a string to EEPROM address 2*/
	eeprom_write_block(2,"SUCCESSFUL!!!",14);
	
	/*read a string from EEPROM address 2*/
	eeprom_read_block(2,buffer,14);
	
	/*debug the read string*/
	print_dbg(buffer);

  while(1);
}
