/*
(C) ALVIDI 22.7.2011
 
Disclaimer
----------
Wir haften nicht fr die Eignung der Software fr einen bestimmten, vom Kunden beabsichtigten Verwendungszweck.
We are not liable for the problems, which occur during incorrect usage of our products.

Wir bernehmen keine Haftung fr die Fehler, die im Laufe der Nutzung auftreten knnen.
We don't take liability for mistakes, which may occur while using our products.

Wir bernehmen keine Verantwortung fr mgliche Schden, die bei der Nutzung des Programms entstehen knnen.
We don't take responsibility for possible damages, which may happen while using our products.

Dieses Programm ist freie Software. Sie knnen es verffentlichen, weitergeben und/oder modifizieren. 
This program is freeware. You may publish it, refer and/or modify.

Diese Software ist kompatibel mit dem AVR32 Modul http://alvidi.de/avr32_uc3cram.html
This software is compatible with the AVR32 Module http://alvidi.de/avr32_uc3cram_en.html
*/

#ifndef _UC3CRAM_H_
#define _UC3CRAM_H_

#include "compiler.h"

#ifdef AVR32_SCIF_101_H_INCLUDED
#define AVR32_SCIF_OSCCTRL0_STARTUP_2048_RCOSC  0x00000003
#define AVR32_SCIF_OSCCTRL0_STARTUP_16384_RCOSC 0x00000006
#define AVR32_SCIF_OSCCTRL32_STARTUP_8192_RCOSC 0x00000002
#endif

/* Osc32 frequency: Hz.*/
#define FOSC32          AVR32_SCIF_OSC32_FREQUENCY      
       
/* Osc32 startup time: RCOsc periods. */                    
#define OSC32_STARTUP   AVR32_SCIF_OSCCTRL32_STARTUP_8192_RCOSC

/* Osc0 frequency: Hz. */
#define FOSC0           12000000                         
/* Osc0 startup time: RCOsc periods.*/     
#define OSC0_STARTUP    AVR32_SCIF_OSCCTRL0_STARTUP_2048_RCOSC  

/* These are documented in services/basic/clock/uc3a0_a1/osc.h */
#define BOARD_OSC0_HZ           12000000
#define BOARD_OSC0_STARTUP_US   17000
#define BOARD_OSC0_IS_XTAL      true
#define BOARD_OSC32_HZ          32768
#define BOARD_OSC32_STARTUP_US  71000
#define BOARD_OSC32_IS_XTAL     true

/* Part header file of used SDRAM(s). */
#define SDRAM_PART_HDR 	"mt48lc16m16a2tg7e/mt48lc16m16a2tg7e.h"

/* Data bus width to use the SDRAM */
#define SDRAM_DBW       16

/* Push Button with depended GPIO Connection */
#define GPIO_PUSH_BUTTON              AVR32_PIN_PA14
#define GPIO_PUSH_BUTTON_PRESSED      0

#endif  // _UC3CRAM_H_
